<?php
namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Bco21100ExtratoDeMovimentacaoBancariaFactory {
    
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function execProcMovimentacaBancaria(
        $cdempresa, $cdreducont, $saldoinicial, $dtperiodoini, $dtperiodofin
    ){
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'MOVIMENTACA_BANCARIA');
        $procedure->addParam(new Param('P_CDEMPRESA'    , Param::PARAM_INPUT , $cdempresa    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDREDUCONT'   , Param::PARAM_INPUT , $cdreducont   , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SALDOINICIAL' , Param::PARAM_INPUT , $saldoinicial , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTPERIODOINI' , Param::PARAM_INPUT , $dtperiodoini , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTPERIODOFIN' , Param::PARAM_INPUT , $dtperiodofin , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_RESULT'       , Param::PARAM_OUTPUT, null          , Param::PARAM_TYPE_STR, 20));
        $nrseqmovbanc = $procedure->execute();

        return intval($nrseqmovbanc['P_RESULT']);
    }

}